﻿import-module WindowsAutoPilotIntune

Connect-MSGraph

# target is usb drive attached (if present)	
$PC = Get-WmiObject -Class Win32_BIOS
$Serial = $PC.SerialNumber
$USBDisk = Get-WmiObject -Class Win32_logicaldisk -Filter "DriveType = '2'"
$ValueIsNOTPresent = [string]::IsNullOrEmpty($USBDisk)

If (!($ValueIsNOTPresent))
{
    [String]$USBDriveLetter = $USBDisk.deviceid[0]
    # if drive letter does NOT contain : (dependant on os / ps version) add the colon 
    If (!($USBDriveLetter.contains(":")))
    {
        $USBDriveLetter = $USBDriveLetter + ":"
    }

    # MAKE DIRECTORY
    $OutAPDir = $USBDriveLetter + "\" + $serial + "_AutoPilotInfos"
    If (!(Test-Path $OutAPDir))
    {
        New-Item -Path $OutAPDir -ItemType Directory
    }
    $OutAPDeviceCSVFile = $OutAPDir + "\" + $serial + "_AutoPilotDevice.csv"
    $OutAPEventCSVFile = $OutAPDir + "\" + $serial + "_AutoPilotEvent.csv"
}
Else
{
    # default files go to %temp% if no usb is present
    $OutAPEventCSVFile = $env:TEMP + "\" + $serial + "_AutoPilotEvent.csv"
    $OutAPDeviceCSVFile = $env:TEMP + "\" + $serial + "_AutoPilotDevice.csv"
}


# use WindowsAutoPilotIntune module
Get-AutoPilotEvent | export-csv -NoTypeInformation -path $OutAPEventCSVFile
Get-AutopilotDevice | export-csv -NoTypeInformation -Path $OutAPDeviceCSVFile

write-host "AutoPilot Event Infos written to $OutAPEventCSVFile " -ForegroundColor Green
write-host "AutoPilot DEvice Infos written to $OutAPDeviceCSVFile " -ForegroundColor Green

