﻿param(
     [Parameter()]
     [string]$driverpath = "E:\Drivers\Lenovo"
 )

$ErrorActionPreference = 'silentlycontinue'
# taken from parameter
# $driverpath = "C:\Drivers\Lenovo"

$OutFile = $env:windir + "\temp\install-infs-pnputil-lenovo.log"
$TimeStamp = get-date -uformat "%d.%m.%Y-%H.%M.%S"
$Ausgabe = "start install-infs-pnputil-lenovo.ps1 with drivers from path " + $driverpath  + " at: " + $TimeStamp
$Ausgabe | Out-File -FilePath $OutFile -Append

if (Test-Path $driverpath)
	{
		$driverfiles = get-childitem -path $driverpath -Recurse | where {($_.extension -eq ".inf")} | select fullname
		foreach($driverfile in $driverfiles)
			{
				$driverfile.fullname
				$TimeStamp = get-date -uformat "%d.%m.%Y-%H.%M.%S"
				$command = "pnputil.exe /add-driver " + '"' + $driverfile.fullname + '"' + " /install"
				$Ausgabe = "start " + $command + " at: " + $TimeStamp
				$Ausgabe | Out-File -FilePath $OutFile -Append
				Invoke-Expression $command | Out-File -FilePath $OutFile -Append
			}
	}


$TimeStamp = get-date -uformat "%d.%m.%Y-%H.%M.%S"
$Ausgabe = "install-infs-pnputil-lenovo.ps1 finished at: " + $TimeStamp
$Ausgabe | Out-File -FilePath $OutFile -Append

# copy log to deployment share logfiles dir incl. serial no in filename
$PC = Get-WmiObject -Class Win32_BIOS
$Serial = $PC.SerialNumber

$BackupFileName = "Z:\logfiles\" + $Serial + "-install-infs-pnputil-lenovo.log"
Copy-Item -Path $OutFile -Destination $BackupFileName -force